CON

' ptra[0] = VSYNC_HUB
' ptra[1] = VIDEO_SDRAM_PTR
' ptra[2] = SDRAM_COMMANDS
' ptra[3] = WORKRAM
' ptra[4] = SDRAM FRAME0
' ptra[5] = SDRAM FRAME1

DAT

                org     0
Wired_Driver    rdlong  vsptr,ptra++
                rdlong  vbaseptr,ptra++
                rdlong  hub_loc,ptra++
                mov     sd_loc,hub_loc
                add     sd_loc,#4
                rdlong  hub0ptr,ptra++
                mov     hub1ptr,hub0ptr
                add     hub1ptr,sd_add
                mov     hub2ptr,hub1ptr
                add     hub2ptr,sd_add
                mov     hubdptr,hub2ptr
                add     hubdptr,sd_add
                mov     hub0_rd,hub0ptr
                or      hub0_rd,#7
                mov     hub1_rd,hub1ptr
                or      hub1_rd,#7
                mov     hub2_rd,hub2ptr
                or      hub2_rd,#7
                mov     hub1_wr,hubdptr
                or      hub1_wr,#8|7
                rdlong  srcptr,ptra++
                rdlong  dstptr,ptra++

                rdlong  xlp,vsptr
                tjz     xlp,#$-1
                wrlong  wzero,vsptr
                
:loop
                mov     sdptr,srcptr
                mov     d1ptr,dstptr

                sub     sdptr,sd_add
                wrlong  sdptr,sd_loc
                wrlong  hub1_rd,hub_loc
                rdlong  :tmp,hub_loc
                tjnz    :tmp,#$-1

                add     sdptr,sd_add
                wrlong  sdptr,sd_loc
                wrlong  hub2_rd,hub_loc
                rdlong  :tmp,hub_loc
                tjnz    :tmp,#$-1

                setquad #:quad0

                mov     ylp,sixhundredminus2
:ylp
                add     d1ptr,sd_add
                add     sdptr,sd_add

                setptra hub1ptr
                reps    #256/4*2,#2
                setptrb hub0ptr
                rdquad  ptra++
                wrquad  ptrb++

                rdlong  :tmp,hub_loc
                tjnz    :tmp,#$-1
                add     sdptr,sd_add
                wrlong  sdptr,sd_loc
                sub     sdptr,sd_add
                wrlong  hub2_rd,hub_loc
                mov     :ptr1,hub0ptr
                mov     :ptr2,hub1ptr
                mov     :ptr3,hub2ptr
                setptrb hubdptr
                addptrb #1
                rdlong  :tmp,hub_loc
                tjnz    :tmp,#$-1
                
                mov     xlp,eighthundredminus2
:xlp            setptra :ptr1
                rdbytec :by1,ptra++
                rdbytec :by2,ptra++
                rdbytec :by3,ptra

                setptra :ptr2
                rdbytec :by4,ptra++
                rdbytec :by5,ptra++
                rdbytec :by6,ptra

                setptra :ptr3
                add     :ptr1,#1
                add     :ptr2,#1
                add     :ptr3,#1
                rdbytec :by7,ptra++
                rdbytec :by8,ptra++
                rdbytec :by9,ptra

                cmp     :by5,type0 wz
        if_z    jmp     #:skp
                cmp     :by5,type2 wz
        if_nz   jmp     #:not2
                mov     :cnt,#0
                cmp     :by1,type1 wz
        if_z    add     :cnt,#1
                cmp     :by2,type1 wz
        if_z    add     :cnt,#1
                cmp     :by3,type1 wz
        if_z    add     :cnt,#1
                cmp     :by4,type1 wz
        if_z    add     :cnt,#1
                cmp     :by6,type1 wz
        if_z    add     :cnt,#1
                cmp     :by7,type1 wz
        if_z    add     :cnt,#1
                cmp     :by8,type1 wz
        if_z    add     :cnt,#1
                cmp     :by9,type1 wz
        if_z    add     :cnt,#1
                cmp     :cnt,#2 wz
        if_z    mov     :by5,type1
                cmp     :cnt,#1 wz
        if_z    mov     :by5,type1
                jmp     #:skp
:not2           cmp     :by5,type1 wz
        if_z    mov     :by5,type3
        if_z    jmp     #:skp
:not1           cmp     :by5,type3 wz
        if_z    mov     :by5,type2
:skp            wrbyte  :by5,ptrb++
                djnz    xlp,#:xlp

                wrlong  d1ptr,sd_loc
                wrlong  hub1_wr,hub_loc
'               rdlong  :tmp,hub_loc
'               tjnz    :tmp,#$-1

                djnz    ylp,#:ylp

                mov     xlp,srcptr
                mov     srcptr,dstptr
                mov     dstptr,xlp
                wrlong  srcptr,vbaseptr

                jmp     #:loop

:quad0  long    0
:quad1  long    0
:quad2  long    0
:quad3  long    0
:cnt    long    0
:by1    long    0
:by2    long    0
:by3    long    0
:by4    long    0
:by5    long    0
:by6    long    0
:by7    long    0
:by8    long    0
:by9    long    0
:tmp    long    0
:ptr1   long    0
:ptr2   long    0
:ptr3   long    0

vsptr   long    0
wzero   long    0

sixhundredminus2        long    600-2
eighthundredminus2      long    800-2

type0   long    0       'black
type1   long    $ff     'white  'electron
type2   long    $1f     'orange 'copper
type3   long    $7f     'blue   'tail

vbaseptr long   0

hub_loc long    0
sd_loc  long    0
hub0_rd long    0
hub1_rd long    0
hub2_rd long    0
hub1_wr long    0

hub0ptr long    0
hub1ptr long    0
hub2ptr long    0
hubdptr long    0

sd_add  long    1024
sdptr   long    0
d1ptr   long    0

ylp     long    0
xlp     long    0

srcptr  long    0
dstptr  long    0
